"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.zwenKeepSection = exports.selectLastNewCombinedReducer = exports.selectCombinedReducers = exports.selectCombineReducersMethod = exports.selectDescribes = exports.selectDefaultImports = exports.selectExportConstNames = exports.selectExportsAll = exports.selectExports = void 0;

var _config = _interopRequireDefault(require("../config"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const escapeRegEx = regexStr => regexStr.replace(/[-\/\\^$*+?.()|[\]{}]/g, '\\$&');

const indent = escapeRegEx(_config.default.indent);
const selectExports = new RegExp('export(.+?(?=export|$))', 'gs');
exports.selectExports = selectExports;
const selectExportsAll = new RegExp('export \\*(.+?(?=export \\*|$))', 'gs');
exports.selectExportsAll = selectExportsAll;
const selectExportConstNames = new RegExp('(?<=\nexport const )\\w*', 'gs');
exports.selectExportConstNames = selectExportConstNames;
const selectDefaultImports = new RegExp('import \\w(.+?(?=import|$|\\n\\n))', 'gs');
exports.selectDefaultImports = selectDefaultImports;
const selectDescribes = new RegExp(`(?<=\\n${indent})describe(.+?(?=${indent}describe|\\n}\\)))`, 'gs');
exports.selectDescribes = selectDescribes;
const selectCombineReducersMethod = new RegExp('combineReducers\\({\\n');
exports.selectCombineReducersMethod = selectCombineReducersMethod;
const selectCombinedReducers = new RegExp(`(?<=combineReducers\\({\\n(${indent}\\w+,\\n)*)${indent}\\w+,\\n`, 'g');
exports.selectCombinedReducers = selectCombinedReducers;
const selectLastNewCombinedReducer = new RegExp(`(?<=combineReducers\\({\\n( {2}\\w+,\\n)*) {2}\\w+,\\n$`, 'g');
exports.selectLastNewCombinedReducer = selectLastNewCombinedReducer;
const zwenKeepSection = new RegExp('^\\/\\* zwen-keep-start \\*\\/.*\\/\\* zwen-keep-end \\*\\/', 'gs');
exports.zwenKeepSection = zwenKeepSection;