"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.exportAllFromReducers = exports.exportDefaultCombineReducers = exports.describeTestEnd = exports.describeTestStart = exports.importNamedFrom = exports.importAllAsFrom = exports.importDefaultFrom = exports.exportAllFrom = exports.exportStringConst = exports.exportDefaultAs = void 0;

const exportDefaultAs = name => `export { default as ${name} } from './${name}';\n`;

exports.exportDefaultAs = exportDefaultAs;

const exportStringConst = (name, value) => `export const ${name} = '${value}';\n`;

exports.exportStringConst = exportStringConst;

const exportAllFrom = from => `export * from './${from}';\n`;

exports.exportAllFrom = exportAllFrom;

const importDefaultFrom = (name, from) => `import ${name} from '${from}';\n`;

exports.importDefaultFrom = importDefaultFrom;

const importAllAsFrom = (as, from) => `import * as ${as} from '${from}';\n`;

exports.importAllAsFrom = importAllAsFrom;

const importNamedFrom = (name, from) => `import { ${name} } from '${from}';\n`;

exports.importNamedFrom = importNamedFrom;

const describeTestStart = path => `describe('${path}', () => {\n`;

exports.describeTestStart = describeTestStart;

const describeTestEnd = () => `});\n`; // REDUCERS


exports.describeTestEnd = describeTestEnd;

const exportDefaultCombineReducers = () => 'export default combineReducers({\n'; // SELECTORS


exports.exportDefaultCombineReducers = exportDefaultCombineReducers;

const exportAllFromReducers = () => `/* zwen-keep-start */\n` + `export * from '@/reducers';\n` + `/* zwen-keep-end */\n\n`;

exports.exportAllFromReducers = exportAllFromReducers;