"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _yeomanGenerator = _interopRequireDefault(require("yeoman-generator"));

var r = _interopRequireWildcard(require("../constants/regex"));

var t = _interopRequireWildcard(require("../constants/templateStrings"));

var _utils = require("../utils");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const PATH_PREFIX = 'middleware';

class MiddlewareGenerator extends _yeomanGenerator.default {
  constructor(args, options) {
    super(args, options);

    _defineProperty(this, "filesToWrite", []);

    _defineProperty(this, "templateConfig", {});

    _defineProperty(this, "indent", void 0);

    _defineProperty(this, "destDir", void 0);

    _defineProperty(this, "absolutePath", void 0);

    _defineProperty(this, "fileName", void 0);

    _defineProperty(this, "destPath", '');

    _defineProperty(this, "topLevelPath", '');

    this.indent = options.indent;
    this.destDir = options.destDir;
    this.absolutePath = `${options.srcDir}/${PATH_PREFIX}`;
    this.fileName = options.fileName;
  }

  initializing() {
    if (this.destDir.length > 0) {
      this.log('We do not support subdirectories for middleware. Please specify only a name.');
      process.exit(0);
    }
  }

  configuring() {
    this.templateConfig = {
      MIDDLEWARE_NAME: this.fileName,
      indent: (amount = 1) => this.indent.repeat(amount)
    };
  }

  addExports() {
    const newExport = t.exportDefaultAs(this.fileName); // read

    const indexFile = this.fs.read(`${this.absolutePath}/index.js`, {
      defaults: ''
    }); // update

    const updatedIndexFile = (0, _utils.addToFile)(indexFile, newExport, r.selectExports); // write

    this.filesToWrite.push({
      name: `${this.absolutePath}/index.js`,
      content: updatedIndexFile
    });
  }

  addReducer() {
    this.fs.copyTpl(this.templatePath(`${PATH_PREFIX}/file.ejs`), this.destinationPath(`${this.absolutePath}/${this.fileName}.js`), this.templateConfig);
  }

  addReducerTest() {
    this.fs.copyTpl(this.templatePath(`${PATH_PREFIX}/test.ejs`), this.destinationPath(`${this.absolutePath}/${this.fileName}.test.js`), this.templateConfig);
  }

  writing() {
    this.filesToWrite.forEach(({
      name,
      content
    }) => this.fs.write(name, `${content.trim()}\n`));
  }

}

exports.default = MiddlewareGenerator;