"use strict";

require("@babel/polyfill");

require("./prototypes");

var _path = _interopRequireDefault(require("path"));

var _yeomanEnvironment = _interopRequireDefault(require("yeoman-environment"));

var _config = _interopRequireDefault(require("./config"));

var _generators = require("./generators");

var _logger = _interopRequireDefault(require("./logger"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

module.exports = (args, flags) => {
  const [command, destPath] = args;

  if (flags.version != null || flags.v) {
    _logger.default.version();

    return;
  }

  if (flags.help != null || flags.h || !command) {
    _logger.default.help();

    return;
  }

  const env = _yeomanEnvironment.default.createEnv();

  if (_generators.registeredGenerators.includes(command)) {
    if (!destPath) {
      _logger.default.missingArgument('PATH_WITH_NAME');

      return;
    }

    const {
      name: fileName,
      dir
    } = _path.default.parse(destPath);

    const options = _objectSpread({}, _config.default, {
      classComp: flags.classComp != null || flags.c,
      destDir: dir.split('/').filterEmptyStrings(),
      fileName
    });

    env.register(require.resolve(`./generators/${command}`), `zwen:${command}`);
    env.run(`zwen:${command}`, options);
  } else {
    _logger.default.unknownCommand(command);
  }
};