"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var r = _interopRequireWildcard(require("../constants/regex"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const defaultOptions = {
  appendixIfNew: '',
  prefixForAll: '',
  replaceStringSeparator: '',
  separator: '\n',
  suffixForAll: ''
};

var _default = (file, addition, selector = /a^/, // default: match nothing
options = {}) => {
  const opts = _objectSpread({}, defaultOptions, options);

  if (file.includes(addition.trim())) {
    return file;
  }

  let keptSection = '';
  const keptSectionMatch = file.match(r.zwenKeepSection);

  if (keptSectionMatch) {
    keptSection = keptSectionMatch[0];
    file = file.replace(keptSection, '');
  }

  const selection = file.match(selector) || [];
  const stringToReplace = selection.join(opts.replaceStringSeparator);

  if (stringToReplace === '') {
    const additionWithAffixes = opts.prefixForAll + addition + opts.suffixForAll;
    return keptSection + file + additionWithAffixes + opts.appendixIfNew;
  }

  const stringToInsert = selection.concat(addition).map(c => `${opts.prefixForAll}${c.trim()}${opts.suffixForAll}`).sort().join(opts.separator);
  return keptSection + file.replace(stringToReplace, stringToInsert);
};

exports.default = _default;